Unit Snd;
Interface

Type
  tSndStruct = Record
    Sound     : Pointer;
    SndLen    : Word;
    IsPlaying : Pointer;
    Frequency : Word;
  End;

Const
  NotPlaying = 0; PlayingNotPendening = 1;   PendingSound   = 2;
  FullRight  = 0; FullLeft            = 127; FrontAndCenter = 64;

  PCM_8_Mono   = 0; PCM_16_Mono   = 2;
  PCM_8_Stereo = 1; PCM_16_Stereo = 3;

  NotSupported = 0; IsSupported = 1;

  PlayBack    = 1;   Massage     = 2;   FixedFreq  = 4;    UsesTimer   = 8;
  ShareTimer  = 16;  LoopPend    = 32;  StereoPan  = 64;   StereoPlay  = 128;
  AudioRecord = 256; DMABackFill = 512; PCM16      = 1024; PCM16Stereo = 2048;

  Version : Word = 0;

Procedure DigPlay(Var Struct);
Function  SoundStatus:Word;
Procedure WaitSound;
Procedure MessageAudio(Var Struct);
Procedure DigPlay2(Var Struct);
Function  AudioCapabilities(Var Frequensy:Word):Word;
Function  ReportAudioSample:Word;
Function  SetCallBackAddress(Var Proc):Word;
Procedure StopSound;
Procedure SetAudioHardware(IRQ,Port,Other:Word);
Function  ReportCallBackAddress:Word;
Procedure SetTimerDivisorRate(IntFrequensy:Word);
Function  PostAudioPending(Var Struct):Word;
Function  AudioPendingStatus:Word;
Function  SetStereoPan(Pan:Word):Word;
Function  SetPlayMode(Mode:Word):Word;
Function  ReportPendingAddress:Pointer;
Function  ReportSemaphoreAddress:Pointer;
Function  SetWritingMode(Mode:Word):Word;
Procedure StopNextLoop;
Function  SetReciveWriteDMAMode(Mode:Word):Word;
Function  ReportDMACounter:Word;
Function  TestDMABuffer(Var Struct; Length:Word):Word;
Function  SetICMVolume(Left,Right:Word):Word;
Procedure SetDPMIMode(Mode:Word);

Implementation

Procedure DigPlay(Var Struct); Assembler;
Asm
  Push Ds
  Push Si
  Mov  Ax,$0688
  Lds  Si,[Struct]
  Int  $66
  Pop  Si
  Pop  Ds
End;

Function  SoundStatus:Word; Assembler;
Asm
  Mov  Ax,$0689
  Int  $66
  Mov  Word ptr Version,Bx
End;

Procedure WaitSound; Assembler;
Asm
@Loop:
  Mov  Ax,$0689
  Int  $66
  Or   Ax,Ax
  Jnz  @Loop
End;

Procedure MessageAudio(Var Struct); Assembler;
Asm
  Push Ds
  Push Si
  Mov  Ax,$068A
  Lds  Si,[Struct]
  Int  $66
  Pop  Si
  Pop  Ds
End;

Procedure DigPlay2(Var Struct); Assembler;
Asm
  Push Ds
  Push Si
  Mov  Ax,$068B
  Lds  Si,[Struct]
  Int  $66
  Pop  Si
  Pop  Ds
End;

Function  AudioCapabilities(Var Frequensy:Word):Word; Assembler;
Asm
  Mov  Ax,$068C
  Int  $66
  Mov  Word ptr Frequensy,Dx
End;

Function  ReportAudioSample:Word; Assembler;
Asm
  Mov  Ax,$068D
  Int  $66
End;

Function  SetCallBackAddress(Var Proc):Word; Assembler;
Asm
  Mov  Bx,Word ptr [Proc+0]
  Mov  Dx,Word ptr [Proc+2]
  Mov  Ax,$068E
  Int  $66
End;

Procedure StopSound; Assembler;
Asm
  Mov  Ax,$068F
  Int  $66
End;

Procedure SetAudioHardware(IRQ,Port,Other:Word); Assembler;
Asm
  Mov  Ax,$0690
  Mov  Bx,[IRQ]
  Mov  Cx,[Port]
  Mov  Dx,[Other]
  Int  $66
End;

Function  ReportCallBackAddress:Word; Assembler;
Asm
  Mov  Ax,$0691
  Int  $66
End;

Procedure SetTimerDivisorRate(IntFrequensy:Word); Assembler;
Asm
  Mov  Ax,$0693
  Mov  Dx, Word ptr IntFrequensy
  Int  $66
End;

Function  PostAudioPending(Var Struct):Word; Assembler;
Asm
  Push Ds
  Push Si
  Mov  Ax,$0695
  Lds  Si,[Struct]
  Int  $66
  Pop  Si
  Pop  Ds
End;

Function  AudioPendingStatus:Word; Assembler;
Asm
  Mov  Ax,$0696
  Int  $66
End;

Function  SetStereoPan(Pan:Word):Word; Assembler;
Asm
  Mov  Ax,$0697
  Mov  Dx,Word ptr Pan
  Int  $66
End;

Function  SetPlayMode(Mode:Word):Word; Assembler;
Asm
  Mov  Ax,$0698
  Mov  Dx,Word ptr Mode
  Int  $66
End;

Function  ReportPendingAddress:Pointer; Assembler;
Asm
  Mov  Ax,$0699
  Int  $66
  Mov  Bx,Ax
  Mov  Ax,Dx
  Mov  Dx,Bx
End;

Function  ReportSemaphoreAddress:Pointer; Assembler;
Asm
  Mov  Ax,$0699
  Int  $66
  Mov  Ax,Dx
  Mov  Dx,Bx
End;

Function  SetWritingMode(Mode:Word):Word; Assembler;
Asm
  Mov  Ax,$069A
  Mov  Dx,Word ptr Mode
  Int  $66
End;

Procedure StopNextLoop; Assembler;
Asm
  Mov  Ax,$069B
  Int  $66
End;

Function  SetReciveWriteDMAMode(Mode:Word):Word; Assembler;
Asm
  Mov  Ax,$069C
  Mov  Dx,Word ptr Mode
  Int  $66
End;

Function  ReportDMACounter:Word; Assembler;
Asm
  Mov  Ax,$069D
  Int  $66
End;

Function  TestDMABuffer(Var Struct; Length:Word):Word; Assembler;
Asm
  Push Es
  Mov  Ax,$069E
  Les  Bx,[Struct]
  Mov  Cx,[Length]
  Int  $66
  Pop  Es
End;

Function  SetICMVolume(Left,Right:Word):Word; Assembler;
Asm
  Mov  Ax,$069F
  Mov  Bx,Word ptr Left
  Mov  Cx,Word ptr Right
  Int  $66
End;

Procedure SetDPMIMode(Mode:Word); Assembler;
Asm
  Mov  Ax,$06A0
  Mov  Dx,Word ptr Mode
  Int  $66
End;

Begin
End.